      subroutine DOY (IYR4,ICMO,ICDY,IDOY,ISTAT)

c DOY - [MUELLER.FS.GEN]CSMGENLB
c Convert 4-digit year, calendar month and calendar day
c  (IYR4, ICMO, and ICDY) to day of year (IDOY).
c Valid for 1901=<IYR4=<2099 (simple leap-year test for this range).
c ISTAT= 0 for success;
c      = 1 if IYR4 is out-of-range;
c      = 2 if ICMO is out-of-range;
c      = 3 if ICDY is out-of-range.
c      If ISTAT>0, return with IDOY=0.
c Written by C.Mueller, USGS.

      dimension MDAYS(12)

      ISTAT = 0
      IDOY = 0
      if (IYR4.lt.1901.or.IYR4.gt.2099) then
        ISTAT = 1
        return
      endif
      ILEAP = 0
      if (MOD(IYR4,4).eq.0) ILEAP = 1
      MDAYS(1) = 31
      MDAYS(2) = 28+ILEAP
      MDAYS(3) = 31
      MDAYS(4) = 30
      MDAYS(5) = 31
      MDAYS(6) = 30
      MDAYS(7) = 31
      MDAYS(8) = 31
      MDAYS(9) = 30
      MDAYS(10) = 31
      MDAYS(11) = 30
      MDAYS(12) = 31
      if (ICMO.lt.1.or.ICMO.gt.12) then
        ISTAT = 2
        return
      endif
      if (ICDY.lt.1.or.ICDY.gt.MDAYS(ICMO)) then
        ISTAT = 3
        return
      endif
      IDOY = ICDY
      do 1 I=1,ICMO-1
1        IDOY = IDOY+MDAYS(I)
      return

      end
