      Subroutine Hilbert(y, npw2, envelope, freq_inst)

* Computes the Hilbert tranform of y and uses it to compute the
* envelope and instantaneous frequency

* Need to include fork.

* Dates: 06/19/02 - Written by D. Boore

      real y(*), envelope(*), freq_inst(*)

      complex work(:)
      allocatable :: work

      allocate (work(npw2))

      nnyq = npw2/2 + 1

      do i = 1, npw2
        work(i) = cmplx(y(i), 0.0)
      end do

      call fork(npw2, work, -1.0)

      do i = nnyq , npw2
        work(i) = 0.0
      end do

      do i = 1, nnyq - 1
        work(i) = 2.0*work(i)
      end do

      call fork(npw2, work, +1.0)

      do i = 1, npw2
        envelope(i) = cabs(work(i))
        freq_inst(i) = atan2(aimag(work(i)),real(work(i)))
      end do

      deallocate (work)

      return
      end

      