* ------------------------------ BEGIN ZEROPAD2 --------------------
      subroutine ZEROPAD2 (Y,NIN,NTOTIN,NPW2)

c Calculates NPW2, the next power-of-2 greater than NTOTIN.
c Pads time-series array Y with (NPW2-NIN) zeroes.  With this program 
c the window of the data, which determines NIN, can be different 
c for different time series, yet the overall length of 
c the time series used in the FFT can 
c be the same (determined by NTOTIN), thus guaranteeing 
c that the frequencies for which FFT
c values are computed are the same.
c I assume that the user makes sure that NTOTIN .ge. NIN.
c Written by Chuck MUeller, USGS; modified by Dave Boore,
c 5/1/87.

      real Y(*)
      
      npw2 = 2
1     if ( npw2 .lt. ntotin) then
           npw2 = 2 * npw2
           go to 1
      endif

      do 20 I=NIN+1,NPW2
20       Y(I) = 0.0

      return
      end
* ------------------------------ END ZEROPAD2 --------------------
