      subroutine digitize(y_in, y_out, ny, dy, round)

* "digitizes" input time series

* Dates: 12/14/01 - Written by D. Boore
*        12/20/01 - Added option to use either roundoff or exceedance
*        07/27/02 - Read in dy rather than nbits, y_full_scale.  They are
*                   related by dy = 2.0*y_full_scale/2.0**float(nbits)
*        08/12/02 - Renamed from a2d, because that name might
*                   be interpreted as "acceleration to displacement", since
*                   I recently wrote smc_v2a to convert velocity 
*                   to acceleration.
*        09/04/02 - I changed the relation between dy, y_full_scale, nbits
*                   to reflect +-y_full_scale (the equation is the same,
*                   but I move a factor of 2 to the numerator).
*        10/09/02 - Use my function "floor" rather than the aint truncation
*                   function (which truncates toward zero)

      real y_in(*), y_out(*)
      logical round

      do i = 1, ny
        if (round) then
          y_out(i) = dy * anint(y_in(i)/dy)
        else
          y_out(i) = dy * floor(y_in(i)/dy)
        end if
      end do

      return
      end

