*----------------- BEGIN dis2va-----------------------------
       subroutine dis2va(dis, npts, dt, vel, acc) 
* Compute Acc and Vel from Dis	
* Dates: 10/28/2005 - Written by Guoquan Wang, NCAT
*        04/30/09 - modified by D. Boore, adding double precision
*                   and assuming displacement at i=0, -1 equals
*                   displacement at i=1 and at i=npts+1, npts+2 equals 
*                   displacement at i=npts (to deal with the case of a
*                   residual displacement).
*                   
	
      double precision  
     :   dm2, dm1, d0, dp1, dp2, 
     :   ddt, ddt2, ddt_2,
     :   f11, f12, f21, f22, f23
      real vel(*)
      real acc(*)
      real dis(*)
      
      ddt = dble(dt)
      ddt2 = ddt*ddt



      do i=1,npts
        vel(i)= 0.0
        acc(i)= 0.0      
      end do
        
! cal vel, centered scheme,derivation
!! Three points  First Derivative
!      do i=2,npts-1	  
!	  vel(i) = (dis(i+1)-dis(i-1))/(2.0d0*dt)
!      end do

!! Five points First Derivative

!! Five Points Second Derivative
 ! a(i)=-1/12*d(i-2)+4/3*d(i-1)-5/2*d(i)+4/3*f(i+1)-1/12*d(i+2)
 
      f11=1.0d0/12.0d0
      f12=2.0d0/3.0d0
        
      f21=-1.0d0/12.0d0
      f22=4.0d0/3.0d0
      f23=-5.0d0/2.0d0
       
      do i=3,npts-2
        dm2 = dble(dis(i-2))
        dm1 = dble(dis(i-1))
        d0  = dble(dis(i))
        dp1 = dble(dis(i+1))
        dp2 = dble(dis(i+2))
        vel(i)=sngl((f11*dm2-f12*dm1+f12*dp1-f11*dp2)/ddt)
        acc(i)=sngl((f21*dm2+f22*dm1+f23*d0+f22*dp1+f21*dp2)/ddt2)
      end do

      i = 1
        dm2 = dble(dis(1))
        dm1 = dble(dis(1))
        d0  = dble(dis(i))
        dp1 = dble(dis(i+1))
        dp2 = dble(dis(i+2))
        vel(i)=sngl((f11*dm2-f12*dm1+f12*dp1-f11*dp2)/ddt)
        acc(i)=sngl((f21*dm2+f22*dm1+f23*d0+f22*dp1+f21*dp2)/ddt2)
      i = 2
        dm2 = dble(dis(1))
        dm1 = dble(dis(i-1))
        d0  = dble(dis(i))
        dp1 = dble(dis(i+1))
        dp2 = dble(dis(i+2))
        vel(i)=sngl((f11*dm2-f12*dm1+f12*dp1-f11*dp2)/ddt)
        acc(i)=sngl((f21*dm2+f22*dm1+f23*d0+f22*dp1+f21*dp2)/ddt2)
      i = npts-1
        dm2 = dble(dis(i-2))
        dm1 = dble(dis(i-1))
        d0  = dble(dis(i))
        dp1 = dble(dis(i+1))
        dp2 = dble(dis(npts))
        vel(i)=sngl((f11*dm2-f12*dm1+f12*dp1-f11*dp2)/ddt)
        acc(i)=sngl((f21*dm2+f22*dm1+f23*d0+f22*dp1+f21*dp2)/ddt2)
      i = npts
        dm2 = dble(dis(i-2))
        dm1 = dble(dis(i-1))
        d0  = dble(dis(i))
        dp1 = dble(dis(npts))
        dp2 = dble(dis(npts))
        vel(i)=sngl((f11*dm2-f12*dm1+f12*dp1-f11*dp2)/ddt)
        acc(i)=sngl((f21*dm2+f22*dm1+f23*d0+f22*dp1+f21*dp2)/ddt2)

 
      return
      end
*----------------- END dis2va -----------------------------
