!-------------------------downsample------------------------------
      subroutine downsample(x,npts_old,npts_new,sps_old,sps_new)
!! purpose: downsampling x, eg. from 256-sps to 80-sps
!! Dates: 06/29/06 - Written by D. M. Boore

      real x(*)
      real y(500000)

      dt_old=1.0/sps_old
      dt_new=1.0/sps_new

! dt_old<dt_new

      print *, 
     :  ' Inside downsample: npts_old, npts_new, sps_old, sps_new = ',
     :                       npts_old, npts_new, sps_old, sps_new

      print *, 
     :  ' Inside downsample: dt_old, dt_new = ',
     :                       dt_old, dt_new

      total_sec=npts_old*dt_old
      npts_new=int(total_sec*sps_new)-1
      
      print *,' Inside downsample: total_sec, npts_new = ', 
     :                             total_sec, npts_new

      y(:)=0.0
      
      y(1) = x(1)
      
      do i = 2, npts_new
        j = 1 + int(float(i-1)*sps_old/sps_new)
        if (j .gt. npts_old) then
          npts_new = i - 1
          print *, ' Inside downsample, reset npts_new to ', npts_new
          go to 200
        end if
        t_new = float(i-1)/sps_new
        t_old = float(j-1)/sps_old
        if (.not.(t_new .ge. t_old .and. 
     :            t_new .le. t_old + dt_old)) then
          npts_new = i - 2
          print *, 
     :      ' Inside downsample, the time relations are incorrect;'//
     :      ' i = , j = ', i, j
          print *, ' And therefore t_old, t_new, t_old+dt_old = ', 
     :                             t_old, t_new, t_old+dt_old
          print *, ' Reset npts_new to ', npts_new
          go to 200
        else  ! new times are OK, find interpolated value
          slope= (t_new - t_old)/dt_old
          y(i)=x(j)+slope*(x(j+1)-x(j))        
        end if
      end do

200   continue

      print *, ' Inside downsample, just before input y to x:'
! input y to x
       do i=1, npts_old
        x(i)=0.0
       end do
       do i=1,npts_new
        x(i)=y(i)
       end do

       return

       end
!--------------------end downsample------------------------------------
