! begin subroutine interpolate_2d
      subroutine interpolate_2d(x, y, n1, n2, ynull,
     :                          x1_interp, x2_interp, y_interp)

! Use bilinear interpolation in the 2d grid x(i,j) to find y_interp 
! corresponding to x1_interp and x2_interp.  
! Returns y_interp = ynull if x1_interp or x2_interp are outside of the range of x.
! The program assumes that x is ordered from small to large.
      
! Comments for locate:
!  finds j such that xx(j) < x <= xx(j+1)
!  EXCEPT if x = xx(1), then j = 1 (logically it would be 0 from
!  the above relation, but this is the same returned value of j
!  for a point out of range).
!  Also, if x = xx(n), j = n-1, which is OK
!  Note that j = 0 or j = n indicates that x is out of range.
!
! See the program test_locate.for to test the routine LOCATE.

! Dates: 05/27/10 - Written by D. Boore, based on interpolate_1d,
!                   using the equations in section 3.6 of 
!                   Press et al, Numerical Recipes (1992).

&&&&&&& THIS VERSION IS NOT CORRECT--It's for 1 d apparently

      real x(n1, n2), y(n1, n2), ynull, 
     :     x1_interp, x2_interp, y_interp, t, u, y1, y2, y3, y4
     
      real work(:)
      allocatable (work)
      
      integer j, k
      
      ndimen_work = max(n1, n2)
      
      allocate work(ndimen_work)

! Find j:

      work = 0.0
      do i = 1, n1
        work(i) = x(i,1)
      end do
      
      call locate(work,n1,x1_interp,j)

      if (j == 0 .or. j == n1) then ! out of range
        y_interp = ynull
        return
      end if
      
! Find k:

      work = 0.0
      do i = 1, n2
        work(i) = x(1,i)
      end do
      
      call locate(work,n2,x2_interp,k)

      if (k == 0 .or. k == n2) then ! out of range
        y_interp = ynull
        return
      end if
      
      t = (x1_interp - x(j))/(x(j+1) - x(j))
      
      y1 = y(j)
      y2 = y(j+1)
      
      y_interp = (1.0-t)*y1 + t*y2
      
      return
      end
! end subroutine interpolate_2d
 