!c ren-raw chen, rutgers business school
!c normal inverse
!c translate from
!http://home.online.no/~pjacklam/notes/invnorm
!c a routine written by john herrero

      real function invnorm(p)
      
! Dates: 07/26/10 - Code cleaned up by D. Boore (use if then
!                   to eliminate use of statement numbers and go to
!                   statements).
      
      real*8 p8, p_low,p_high
      real*8 a1,a2,a3,a4,a5,a6
      real*8 b1,b2,b3,b4,b5
      real*8 c1,c2,c3,c4,c5,c6
      real*8 d1,d2,d3,d4
      real*8 z,q,r
      
      if (p == 0.0 .or. p == 1.0) then
        write(*,*) ' p = ', p, 
     :        ' is invalid; it cannot be 0 or 1, QUITTING!!'
        stop
      end if
      
      p8 = dble(p)

      a1 =  -39.6968302866538
      a2 =  220.946098424521
      a3 = -275.928510446969
      a4 =  138.357751867269
      a5 =  -30.6647980661472
      a6 =    2.50662827745924
      b1 =  -54.4760987982241
      b2 =  161.585836858041
      b3 = -155.698979859887
      b4 =   66.8013118877197
      b5 =  -13.2806815528857
      c1 =   -0.00778489400243029
      c2 =   -0.322396458041136
      c3 =   -2.40075827716184
      c4 =   -2.54973253934373
      c5 =    4.37466414146497
      c6 =    2.93816398269878
      d1 =    0.00778469570904146
      d2 =    0.32246712907004
      d3 =    2.445134137143
      d4 =    3.75440866190742
      
      p_low = 0.02425d0
      p_high = 1.0d0-p_low
      
      if(p8 < p_low) then
        q=dsqrt(-2.0d0*dlog(p8))
        z=(((((c1*q+c2)*q+c3)*q+c4)*q+c5)*q+c6)/
     :    ((((d1*q+d2)*q+d3)*q+d4)*q+1.0d0)
      else if (p8 > p_high) then
        q=dsqrt(-2.0d0*dlog(1.0d0-p8))
        z=-(((((c1*q+c2)*q+c3)*q+c4)*q+c5)*q+c6)/
     :       ((((d1*q+d2)*q+d3)*q+d4)*q+1.0d0)
      else
        q=p8-0.5d0
        r=q*q
        z=(((((a1*r+a2)*r+a3)*r+a4)*r+a5)*r+a6)*q/
     :  (((((b1*r+b2)*r+b3)*r+b4)*r+b5)*r+1.0d0)
      end if
      
      invnorm=z
      
      end
