* -------------------------- BEGIN SMOOTH_LogTriangle --------------------------
      subroutine Smooth_LogTriangle (y, npts, smooth_param)


! **** WARNING:  This is a non-maintained version; see SMOOTH_INTERPOLATE
! **** for the most recent code.

* SMOOTHING OVER LOGARITHMICALLY SPACED FREQUENCIES
* itype = 4: Triangular weighting function 
*   smooth_param = xi, which is the fraction of a decade spanned by the
*                  base of a triangular function


* Dates:  06/19/07 - Written by D. Boore, patterned after smooth_konno.for

      real y(*)
      real work(:)
      allocatable :: work
      
      pi = 4.0*atan(1.0)

      allocate(work(npts))
      
      do i = 1, npts
        work(i) = y(i)
      end do
      
      
      do ic = 1, npts
      
        iz1 = nint(float(ic)*10.0**(-0.5*smooth_param))
        iz2 = nint(float(ic)*10.0**(0.5*smooth_param))
        
        if (iz1 .lt. 1) then
          iz1 = 1
        end if
        if (iz2 .gt. npts) then
          iz2 = npts
        end if
        
        sum = 0.0
        wavg = 0.0
        
        do j = iz1, iz2
          weight = w_logtriangular(j, ic, iz1, iz2, smooth_param)
          wavg = wavg + weight
          sum = sum + weight * work(j)
        end do
        
        y(ic) = sum/wavg
        
      end do  
       
      deallocate(work)

      return
      end
* -------------------------- END Smooth_LogTriangular --------------------------

      function w_logtriangular(j, ic, iz1, iz2, smooth_param)
      
      if (j .eq. ic) then
        w_triangular = 1.0
      else if (j .lt. ic) then          
        w_triangular = 
     :      alog10(float(j)/float(iz1))/alog10(float(ic)/float(iz1)) 
      else
        w_triangular = 1 - 
     :      alog10(float(j)/float(ic))/alog10(float(iz2)/float(ic)) 
      end if
        
      return
      
      end
